/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

"use strict";var e=require("@lexical/html"),t=require("@lexical/link"),n=require("@lexical/mark"),r=require("@lexical/table"),o=require("lexical"),s=require("react"),i=require("react/jsx-runtime");const l=Object.freeze({"\t":"\\t","\n":"\\n"}),a=new RegExp(Object.keys(l).join("|"),"g"),c=Object.freeze({ancestorHasNextSibling:"|",ancestorIsLastChild:" ",hasNextSibling:"├",isLastChild:"└",selectedChar:"^",selectedLine:">"}),u=[e=>e.hasFormat("bold")&&"Bold",e=>e.hasFormat("code")&&"Code",e=>e.hasFormat("italic")&&"Italic",e=>e.hasFormat("strikethrough")&&"Strikethrough",e=>e.hasFormat("subscript")&&"Subscript",e=>e.hasFormat("superscript")&&"Superscript",e=>e.hasFormat("underline")&&"Underline"],f=[e=>e.hasTextFormat("bold")&&"Bold",e=>e.hasTextFormat("code")&&"Code",e=>e.hasTextFormat("italic")&&"Italic",e=>e.hasTextFormat("strikethrough")&&"Strikethrough",e=>e.hasTextFormat("subscript")&&"Subscript",e=>e.hasTextFormat("superscript")&&"Superscript",e=>e.hasTextFormat("underline")&&"Underline"],d=[e=>e.isDirectionless()&&"Directionless",e=>e.isUnmergeable()&&"Unmergeable"],g=[e=>e.isToken()&&"Token",e=>e.isSegmented()&&"Segmented"];function h(e,t,n=[]){const r=e.getChildren(),s=r.length;r.forEach(((e,r)=>{t(e,n.concat(r===s-1?c.isLastChild:c.hasNextSibling)),o.$isElementNode(e)&&h(e,t,n.concat(r===s-1?c.ancestorIsLastChild:c.ancestorHasNextSibling))}))}function m(e,t=!1){const n=Object.entries(l).reduce(((e,[t,n])=>e.replace(new RegExp(t,"g"),String(n))),e);return t?n.replace(/[^\s]/g,"*"):n}function p(e){let t=d.map((t=>t(e))).filter(Boolean).join(", ").toLocaleLowerCase();return""!==t&&(t="detail: "+t),t}function y(e){let t=g.map((t=>t(e))).filter(Boolean).join(", ").toLocaleLowerCase();return""!==t&&(t="mode: "+t),t}function x(e){let t=u.map((t=>t(e))).filter(Boolean).join(", ").toLocaleLowerCase();return""!==t&&(t="format: "+t),t}function $(e){let t=e.getTarget();return null!=t&&(t="target: "+t),t}function S(e){let t=e.getRel();return null!=t&&(t="rel: "+t),t}function C(e){let t=e.getTitle();return null!=t&&(t="title: "+t),t}function N(e,t){const n=new Array(1+t++).join("  "),r=new Array(t-1).join("  ");let o;for(let s=0;s<e.children.length;s++)o=document.createTextNode("\n"+n),e.insertBefore(o,e.children[s]),N(e.children[s],t),e.lastElementChild===e.children[s]&&(o=document.createTextNode("\n"+r),e.appendChild(o));return e}const b=s.forwardRef((function({treeTypeButtonClassName:e,timeTravelButtonClassName:t,timeTravelPanelSliderClassName:n,timeTravelPanelButtonClassName:r,viewClassName:o,timeTravelPanelClassName:l,editorState:a,setEditorState:c,setEditorReadOnly:u,generateContent:f},d){const[g,h]=s.useState([]),[m,p]=s.useState(""),[y,x]=s.useState(!1),[$,S]=s.useState(!1),C=s.useRef(0),N=s.useRef(null),[b,T]=s.useState(!1),[j,k]=s.useState(!1),[L,v]=s.useState(!1),E=s.useRef(),R=s.useRef(0),w=s.useCallback((e=>{const t=++R.current;f(e).then((e=>{t===R.current&&p(e)})).catch((e=>{t===R.current&&p(`Error rendering tree: ${e.message}\n\nStack:\n${e.stack}`)}))}),[f]);s.useEffect((()=>{!L&&a._nodeMap.size>1e3&&(k(!0),!L)||E.current!==a&&(E.current=a,w($),y||h((e=>[...e,[Date.now(),a]])))}),[a,w,$,L,y]);const B=g.length;s.useEffect((()=>{if(b){let e;const t=()=>{const n=C.current;if(n===B-1)return void T(!1);const r=g[n][0],o=g[n+1][0];e=setTimeout((()=>{C.current++;const e=C.current,n=N.current;null!==n&&(n.value=String(e)),c(g[e][1]),t()}),o-r)};return t(),()=>{clearTimeout(e)}}}),[g,b,B,c]);return i.jsxs("div",{className:o,children:[!L&&j?i.jsxs("div",{style:{padding:20},children:[i.jsx("span",{style:{marginRight:20},children:"Detected large EditorState, this can impact debugging performance."}),i.jsx("button",{onClick:()=>{v(!0)},style:{background:"transparent",border:"1px solid white",color:"white",cursor:"pointer",padding:5},children:"Show full tree"})]}):null,L?null:i.jsx("button",{onClick:()=>(w(!$),void S(!$)),className:e,type:"button",children:$?"Tree":"Export DOM"}),!y&&(L||!j)&&B>2&&i.jsx("button",{onClick:()=>{u(!0),C.current=B-1,x(!0)},className:t,type:"button",children:"Time Travel"}),(L||!j)&&i.jsx("pre",{ref:d,children:m}),y&&(L||!j)&&i.jsxs("div",{className:l,children:[i.jsx("button",{className:r,onClick:()=>{C.current===B-1&&(C.current=1),T(!b)},type:"button",children:b?"Pause":"Play"}),i.jsx("input",{className:n,ref:N,onChange:e=>{const t=Number(e.target.value),n=g[t];n&&(C.current=t,c(n[1]))},type:"range",min:"1",max:B-1}),i.jsx("button",{className:r,onClick:()=>{u(!1);const e=g.length-1,t=g[e];c(t[1]);const n=N.current;null!==n&&(n.value=String(e)),x(!1),T(!1)},type:"button",children:"Exit"})]})]})}));function T(e,t){const n=new Set;let r=0;for(const[s]of e._commands)n.add(e.registerCommand(s,(e=>(t((t=>{r+=1;const n=[...t];return n.push({index:r,payload:e,type:s.type?s.type:"UNKNOWN"}),n.length>10&&n.shift(),n})),!1)),o.COMMAND_PRIORITY_CRITICAL));return()=>n.forEach((e=>e()))}exports.TreeView=b,exports.generateContent=function(s,i,l,u,d=!1){const g=s.getEditorState(),b=s._config,T=s._compositionKey,j=s._editable;if(l){let t="";return g.read((()=>{t=function(e){const t=document.createElement("div");return t.innerHTML=e.trim(),N(t,0).innerHTML}(e.$generateHtmlFromNodes(s))})),t}let k=" root\n";const L=g.read((()=>{const e=o.$getSelection();return h(o.$getRoot(),((r,s)=>{const i=`(${r.getKey()})`,l=r.getType()||"",g=r.isSelected();k+=`${g?c.selectedLine:" "} ${s.join(" ")} ${i} ${l} ${function(e,r,s=!1){const i=r?r(e,s):void 0;if(void 0!==i&&i.length>0)return i;if(o.$isTextNode(e)){const t=e.getTextContent(),n=0===t.length?"(empty)":`"${m(t,s)}"`,r=function(e){return[x(e),p(e),y(e)].filter(Boolean).join(", ")}(e);return[n,0!==r.length?`{ ${r} }`:null].filter(Boolean).join(" ").trim()}if(t.$isLinkNode(e)){const t=e.getURL(),n=0===t.length?"(empty)":`"${m(t,s)}"`,r=function(e){return[$(e),S(e),C(e)].filter(Boolean).join(", ")}(e);return[n,0!==r.length?`{ ${r} }`:null].filter(Boolean).join(" ").trim()}if(n.$isMarkNode(e))return`ids: [ ${e.getIDs().join(", ")} ]`;if(o.$isParagraphNode(e)){const t=function(e){let t=f.map((t=>t(e))).filter(Boolean).join(", ").toLocaleLowerCase();""!==t&&(t="format: "+t);return t}(e);let n=""!==t?`{ ${t} }`:"";return n+=e.__style?`(${e.__style})`:"",n}return""}(r,u,d)}\n`,k+=function({indent:e,isSelected:t,node:n,nodeKeyDisplay:r,selection:s,typeDisplay:i}){if(!o.$isTextNode(n)||!o.$isRangeSelection(s)||!t||o.$isElementNode(n))return"";const l=s.anchor,u=s.focus;if(""===n.getTextContent()||l.getNode()===s.focus.getNode()&&l.offset===u.offset)return"";const[f,d]=function(e,t){const n=t.getStartEndPoints();if(o.$isNodeSelection(t)||null===n)return[-1,-1];const[r,s]=n,i=e.getTextContent(),l=i.length;let c=-1,u=-1;if("text"===r.type&&"text"===s.type){const t=r.getNode(),n=s.getNode();t===n&&e===t&&r.offset!==s.offset?[c,u]=r.offset<s.offset?[r.offset,s.offset]:[s.offset,r.offset]:[c,u]=e===t?t.isBefore(n)?[r.offset,l]:[0,r.offset]:e===n?n.isBefore(t)?[s.offset,l]:[0,s.offset]:[0,l]}const f=(i.slice(0,c).match(a)||[]).length,d=(i.slice(c,u).match(a)||[]).length;return[c+f,u+f+d]}(n,s);if(f===d)return"";const g=e[e.length-1]===c.hasNextSibling?c.ancestorHasNextSibling:c.ancestorIsLastChild,h=[...e.slice(0,e.length-1),g],m=Array(f+1).fill(" "),p=Array(d-f).fill(c.selectedChar),y=i.length+2,x=Array(r.length+y).fill(" ");return[c.selectedLine,h.join(" "),[...x,...m,...p].join("")].join(" ")+"\n"}({indent:s,isSelected:g,node:r,nodeKeyDisplay:i,selection:e,typeDisplay:l})})),null===e?": null":o.$isRangeSelection(e)?function(e){let t="";const n=x(e);t+=`: range ${""!==n?`{ ${n} }`:""} ${""!==e.style?`{ style: ${e.style} } `:""}`;const r=e.anchor,o=e.focus,s=r.offset,i=o.offset;return t+=`\n  ├ anchor { key: ${r.key}, offset: ${null===s?"null":s}, type: ${r.type} }`,t+=`\n  └ focus { key: ${o.key}, offset: ${null===i?"null":i}, type: ${o.type} }`,t}(e):r.$isTableSelection(e)?function(e){return`: table\n  └ { table: ${e.tableKey}, anchorCell: ${e.anchor.key}, focusCell: ${e.focus.key} }`}(e):function(e){if(!o.$isNodeSelection(e))return"";return`: node\n  └ [${Array.from(e._nodes).join(", ")}]`}(e)}));if(k+="\n selection"+L,k+="\n\n commands:",i.length)for(const{index:e,type:t,payload:n}of i)k+=`\n  └ ${e}. { type: ${t}, payload: ${n instanceof Event?n.constructor.name:n} }`;else k+="\n  └ None dispatched.";const{version:v}=s.constructor;return k+=`\n\n editor${v?` (v${v})`:""}:`,k+=`\n  └ namespace ${b.namespace}`,null!==T&&(k+=`\n  └ compositionKey ${T}`),k+=`\n  └ editable ${String(j)}`,k},exports.registerLexicalCommandLogger=T,exports.useLexicalCommandsLog=function(e){const[t,n]=s.useState([]);return s.useEffect((()=>T(e,n)),[e]),s.useMemo((()=>t),[t])};
